/// <reference types="node" />
/// <reference types="node" />
import readline from "readline";
import { IBulkOperationRunQueryResponse, IBulkOperationRunMutationResponse } from "./types";
export declare function bulkQuery(query: string): Promise<IBulkOperationRunQueryResponse>;
export declare function bulkUpdate({ JSONLReadStream, mutation, }: {
    JSONLReadStream: NodeJS.ReadableStream;
    mutation: string;
}): Promise<IBulkOperationRunMutationResponse>;
export declare function generateJSONLUploadOptions(): Promise<{
    parameters: {
        name: string;
        value: string;
    }[];
    url: string;
}>;
export declare function getBulkUpdateStatus(): Promise<{
    BusyStates: string[];
    status: import("./types").TBulkOperationStatus;
    id: string;
    url: string | null;
    errorCode: number;
    objectCount: number;
}>;
export declare function getBulkQueryStatus(): Promise<{
    BusyStates: string[];
    status: import("./types").TBulkOperationStatus;
    id: string;
    url: string | null;
    errorCode: number;
    objectCount: number;
}>;
export declare function getBulkOperationStatus(type: "MUTATION" | "QUERY"): Promise<{
    BusyStates: string[];
    status: import("./types").TBulkOperationStatus;
    id: string;
    url: string | null;
    errorCode: number;
    objectCount: number;
}>;
export declare function waitForBulkQueryToComplete(interval?: number): Promise<{
    BusyStates: string[];
    status: import("./types").TBulkOperationStatus;
    id: string;
    url: string | null;
    errorCode: number;
    objectCount: number;
}>;
export declare function bulkQueryComplete({ query, lineByLine, }: {
    query: string;
    lineByLine?: boolean;
}): Promise<NodeJS.ReadableStream | readline.Interface>;
